﻿using System;
using System.Collections.Generic;
using System.Linq;

/// <summary>
/// Summary description for PersonRepository
/// </summary>
[Serializable]
public class PersonRepository
{
    private IList<Person> _people = new List<Person>();

    public PersonRepository() 
    {
        this.InitializeData();
    }

    private void InitializeData()
    {
        _people.Add(new Person()
        {
            FirstName = "Otto",
            LastName = "Parts",
            LastLoginDate = new DateTime(2009, 4, 3),
            PersonTypeId = 1,
            PersonTypeTitle = "Expert User",
            Id = 1
        });

        _people.Add(new Person()
        {
            FirstName = "Phil",
            LastName = "McCavity",
            LastLoginDate = new DateTime(2009, 3, 7),
            PersonTypeId = 1,
            PersonTypeTitle = "Power User",
            Id = 2
        });

        _people.Add(new Person()
        {
            FirstName = "Justin",
            LastName = "Case",
            LastLoginDate = new DateTime(2009, 2, 2),
            PersonTypeId = 2,
            PersonTypeTitle = "Power User",
            Id = 3
        });

        _people.Add(new Person()
        {
            FirstName = "Bill",
            LastName = "Ding",
            LastLoginDate = new DateTime(2009, 9, 1),
            PersonTypeId = 3,
            PersonTypeTitle = "Casual User",
            Id = 4
        });
    }

    public IList<Person> GetAll()
    {
        return this._people;
    }

    public Person GetById(int id)
    {
        return (from p in this._people.AsQueryable<Person>()
                where p.Id == id
                select p).SingleOrDefault();
    }

    public void Insert(Person person)
    {
        int id = (from p in this._people.AsQueryable<Person>() select p.Id).Max();
        person.Id = id + 1;
        this._people.Add(person);
    }

    public void Update(Person person)
    {
        foreach (Person p in this._people)
        {
            if (p.Id == person.Id)
            {
                p.FirstName = person.FirstName;
                p.LastName = person.LastName;
                p.LastLoginDate = person.LastLoginDate;
                p.PersonTypeId = person.PersonTypeId;
                p.PersonTypeTitle = person.PersonTypeTitle;
                break;
            }
        }
    }

    public void Delete(Person person)
    {
        this.Delete(person.Id);
    }

    public void Delete(int id)
    {
        this._people.Remove(this.GetById(id));
    }
}