﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class Demos_WebDataGrid_ManualCRUD_demo_Default : System.Web.UI.Page
{
    private PersonRepository _repository = null;

    private PersonRepository Repository
    {
        get
        {
            if (this._repository == null)
            {
                return new WebStateRepository<PersonRepository>().Instance;
            }
            return this._repository;
        }
    }

    private void BindData()
        {
        this.wdg.Rows.Clear();
        this.wdg.DataSource = this.Repository.GetAll();
        this.wdg.DataBind();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        this.BindData();
    }

    protected void wdg_RowAdding(object sender, Infragistics.Web.UI.GridControls.RowAddingEventArgs e)
    {
        string str = e.Values["PersonTypeId"].ToString();
        int tmp;
        Int32.TryParse(str, out tmp);
        Person person = new Person()
        {
            FirstName = e.Values["FirstName"].ToString(),
            LastName = e.Values["LastName"].ToString(),
            PersonTypeId = tmp
        };

        this.Repository.Insert(person);
        this.BindData();
    }

    protected void wdg_RowsDeleting(object sender, Infragistics.Web.UI.GridControls.RowDeletingEventArgs e)
    {
        int id = Convert.ToInt32(e.Row.DataKey[0]);
        this.Repository.Delete(id);
    }

    protected void wdg_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
    {
        string str = e.Values["PersonTypeId"].ToString() ;
        int tmp;
        Int32.TryParse(str,out tmp);
        Person person = new Person()
        {
            Id = Convert.ToInt32(e.Row.DataKey[0]),
            FirstName = e.Values["FirstName"].ToString(),
            LastName = e.Values["LastName"].ToString(),
            PersonTypeId = tmp

        };

        this.Repository.Update(person);
    }
    protected void wdg_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        if ((int)e.Row.Items[2].Value == 0)
        {
            e.Row.Items[2].Text = "";
        }
    }
}
